=== modified file 'debian/control'
--- debian/control	2010-08-23 19:23:15 +0000
+++ debian/control	2010-01-01 15:17:12 +0000
@@ -15,8 +15,7 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid
+	python-avahi, python-gobject, avahi-daemon, adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'mandos'
--- mandos	2010-08-23 19:23:15 +0000
+++ mandos	2010-08-22 13:34:42 +0000
@@ -231,6 +231,10 @@
         self.server_state_changed(self.server.GetState())
 
 
+# XXX Need to add:
+# approved_by_default (Config option for each client)
+# approved_delay (config option for each client)
+# approved_duration (config option for each client)
 class Client(object):
     """A representation of a client host served by this server.
     
@@ -323,10 +327,9 @@
         self.checker_command = config[u"checker"]
         self.current_checker_command = None
         self.last_connect = None
-        self.approvals_pending = 0
         self._approved = None
         self.approved_by_default = config.get(u"approved_by_default",
-                                              True)
+                                              False)
         self.approved_delay = string_to_delta(
             config[u"approved_delay"])
         self.approved_duration = string_to_delta(
@@ -813,10 +816,6 @@
     def approve(self, value=True):
         self._approved = value
         gobject.timeout_add(self._timedelta_to_milliseconds(self.approved_duration, self._reset_approved))
-
-    def approved_pending(self):
-        return self.approvals_pending > 0
-    
     
     ## D-Bus methods, signals & properties
     _interface = u"se.bsnet.fukt.Mandos.Client"
@@ -845,25 +844,19 @@
     @dbus.service.signal(_interface)
     def GotSecret(self):
         "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
+        pass
     
     # Rejected - signal
     @dbus.service.signal(_interface, signature=u"s")
     def Rejected(self, reason):
         "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
+        pass
     
     # NeedApproval - signal
     @dbus.service.signal(_interface, signature=u"db")
     def NeedApproval(self, timeout, default):
         "D-Bus signal"
-        if not self.approved_pending():
-            self.PropertyChanged(dbus.String(u"approved_pending"),
-                                 dbus.Boolean(True, variant_level=1))
+        pass
     
     ## Methods
 
@@ -902,29 +895,7 @@
     
     ## Properties
     
-    # approved_pending - property
-    @dbus_service_property(_interface, signature=u"b", access=u"read")
-    def approved_pending_dbus_property(self):
-        return dbus.Boolean(self.approved_pending())
-    
-    # approved_by_default - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
-    def approved_by_default_dbus_property(self):
-        return dbus.Boolean(self.approved_by_default)
-    
-    # approved_delay - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_delay_dbus_property(self):
-        return dbus.UInt64(self.approved_delay_milliseconds())
-    
-    # approved_duration - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_duration_dbus_property(self):
-        return dbus.UInt64(self._timedelta_to_milliseconds(
-                self.approved_duration))
+    # xxx 3 new properties
     
     # name - property
     @dbus_service_property(_interface, signature=u"s", access=u"read")
@@ -1146,8 +1117,6 @@
                 # established.  Just abandon the request.
                 return
             logger.debug(u"Handshake succeeded")
-
-            approval_required = False
             try:
                 try:
                     fpr = self.fingerprint(self.peer_certificate
@@ -1163,11 +1132,7 @@
                 except KeyError:
                     return
                 
-                if client.approved_delay:
-                    delay = client.approved_delay
-                    client.approvals_pending += 1
-                    approval_required = True
-                
+                delay = client.approved_delay
                 while True:
                     if not client.enabled:
                         logger.warning(u"Client %s is disabled",
@@ -1176,11 +1141,7 @@
                             # Emit D-Bus signal
                             client.Rejected("Disabled")                    
                         return
-                    
-                    if client._approved or not client.approved_delay:
-                        #We are approved or approval is disabled
-                        break
-                    elif client._approved is None:
+                    if client._approved is None:
                         logger.info(u"Client %s need approval",
                                     client.name)
                         if self.server.use_dbus:
@@ -1188,11 +1149,14 @@
                             client.NeedApproval(
                                 client.approved_delay_milliseconds(),
                                 client.approved_by_default)
+                    elif client._approved:
+                        #We have a password and are approved
+                        break
                     else:
                         logger.warning(u"Client %s was not approved",
                                        client.name)
                         if self.server.use_dbus:
-                            # Emit D-Bus signal
+                            # Emit D-Bus signal                        
                             client.Rejected("Disapproved")
                         return
                     
@@ -1232,10 +1196,8 @@
                 if self.server.use_dbus:
                     # Emit D-Bus signal
                     client.GotSecret()
-            
+
             finally:
-                if approval_required:
-                    client.approvals_pending -= 1
                 session.bye()
     
     @staticmethod
@@ -1690,7 +1652,7 @@
                         u"interval": u"5m",
                         u"checker": u"fping -q -- %%(host)s",
                         u"host": u"",
-                        u"approved_delay": u"0s",
+                        u"approved_delay": u"5m",
                         u"approved_duration": u"1s",
                         }
     client_config = configparser.SafeConfigParser(client_defaults)
@@ -1776,13 +1738,13 @@
         client_class = functools.partial(ClientDBus, bus = bus)
     def client_config_items(config, section):
         special_settings = {
-            "approved_by_default":
+            "approve_by_default":
                 lambda: config.getboolean(section,
-                                          "approved_by_default"),
+                                          "approve_by_default"),
             }
         for name, value in config.items(section):
             try:
-                yield (name, special_settings[name]())
+                yield special_settings[name]()
             except KeyError:
                 yield (name, value)
     

